 /*
  * Khoros: $Id: File.h,v 1.3 1992/03/20 23:37:41 dkhoros Exp $
  */

 /*
  * $Log: File.h,v $
 * Revision 1.3  1992/03/20  23:37:41  dkhoros
 * VirtualPatch5
 *
  */ 


/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.

 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>								<<<<
   >>>>	    file name: File.h					<<<<
   >>>>								<<<<
   >>>>   description:						<<<<
   >>>>								<<<<
   >>>> modifications:						<<<<
   >>>>								<<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _File_h_
#define _File_h_


/*
 *  Internal structures for the following transport
 *
 *		file	   -  standard files
 */

/* file structure */
typedef struct
{
	int	fid;
} FileStruct;

#undef  ResourceStruct
#define ResourceStruct FileStruct


int	file_tempnam(),
	file_open(),
	file_close(),
	file_read(),
	file_write(),
	file_lseek(),
	file_tell(),
	file_access(),
	file_unlink(),
	file_lock(),
	file_descriptors();

static TransportInformation file_routines[] =
{
    {
	"Standard Unix Files",
	"file",
	TRUE,
	file_tempnam,
	file_open,
	file_close,
	file_read,
	file_write,
	file_lseek,
	file_tell,
	file_access,
	file_unlink,
	file_lock,
	file_descriptors,

	NULL
    }
};

#endif /* _File_h_ */
/* don`t add after the endif */
