 /*
  * Khoros: $Id: deparser.h,v 1.2 1991/10/02 00:17:25 khoros Exp $
  */

 /*
  * $Log: deparser.h,v $
 * Revision 1.2  1991/10/02  00:17:25  khoros
 * HellPatch2
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.
 * 
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *----------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */


#ifndef _deparser_h_
#define _deparser_h_

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>	     file: deparser.h					 <<<<
   >>>>                                                          <<<<
   >>>>      contains: Deparsing Print Fields                    <<<<
   >>>>                                                          <<<<
   >>>>	     These print fields define the model for each type   <<<<
   >>>>	     of User Interface Specification line that is        <<<<
   >>>>      written out by xvf_deparse_***_line()		 <<<< 
   >>>>                                                          <<<<
   >>>>      written by: Danielle Argiro, Stephanie Hallett,     <<<<
   >>>>			 Ron E. Neher                            <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */


static char 

/* -F @ % gs ps 'l' FormInfoName */
*startform_print = "-F %.1f %d %d %gx%g+%g+%g +%g+%g '%s' %s",

/* -S @ mutually_exclusive */
*startmaster_print = "-S %d %d",

/* -M @ gs ps 'l' SubFormInfoName */
*startsubform_print = "-M %d %d %gx%g+%g+%g +%g+%g '%s' %s",

/* -D @ gs ps 'l' SubMenuInfoName */
*startsubmenu_print = "-D %d %d %gx%g+%g+%g +%g+%g '%s' %s",

/* -d @ % gs 'l'*/
*subformbutton_print ="-d %d %d %gx%g+%g+%g '%s'",

/* -u @ % gs 'l'*/
*psuedosubform_print ="-u %d %d %gx%g+%g+%g '%s'",

/* -n @ % gs 'l' 'des' v  */
*master_action_print = "-n %d %d %gx%g+%g+%g '%s' '%s' %s",
 

/*  -P @ gs ps 'l' PaneInfoName*/
*startpane_print = "-P %d %d %gx%g+%g+%g +%g+%g '%s' %s",


/*  -G % gs ps 'l'*/
*startguide_print = "-G %d %gx%g+%g+%g +%g+%g '%s'",

/* -g @ % gs 'l'*/
*guidebutton_print = "-g %d %d %gx%g+%g+%g '%s'",

/* -Q @ % gs 'l'*/
*quitform_print = "-Q %d %d %gx%g+%g+%g '%s'",


/* -m @ % gs 'l' 'des' v  */
*subform_action_print = "-m %d %d %gx%g+%g+%g '%s' '%s' %s",
 

/*  -H @ gs 'l' 'des' file_path  */
*help_print = "-H %d  %gx%g+%g+%g '%s' '%s' %s",


/* -I @ % * ! ? # gs ps 'def' 'l' 'des' v 'val' 'literal value' */
*input_print = "-I %d %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s '%s' '%s'",

/* -I @ % * ! ? # gs ps 'def' 'l' 'des' v */
*input_write = "-I %d %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s",


/*  -O @ % * ! # ? gs ps 'def' 'l' 'des' v 'val' 'literal value' */
*output_print = "-O %d %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s '%s' '%s'",

/*  -O @ % * ! # ? gs ps 'def' 'l' 'des' v */
*output_write = "-O %d %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s",


/* -i @ % * ! ? gs ps L U def 'l' 'des' v val 'literal value' */
*int_print = "-i %d %d %d %d %d %gx%g+%g+%g +%g+%g %d %d %d '%s' '%s' %s %d '%s'",
 
/* -i @ % * ! ? gs ps L U def 'l' 'des' v */
*int_write = "-i %d %d %d %d %d %gx%g+%g+%g +%g+%g %d %d %d '%s' '%s' %s",


/* -f @ % * ! ? gs ps L U def 'l' 'des' v val 'literal value' */
*float_print = "-f %d %d %d %d %d %gx%g+%g+%g +%g+%g %g %g %g '%s' '%s' %s %g '%s'",

/* -f @ % * ! ? gs ps L U def 'l' 'des' v */
*float_write = "-f %d %d %d %d %d %gx%g+%g+%g +%g+%g %g %g %g '%s' '%s' %s",


/* -l @ % * ! ? gs ps def 'l' 'label0' 'label1' 'des' v val */
*logic_print = "-l %d %d %d %d %d %gx%g+%g+%g +%g+%g %d '%s' '%s' '%s' '%s' %s %d",

/* -l @ % * ! ? gs ps def 'l' 'label0' 'label1' 'des' v */
*logic_write = "-l %d %d %d %d %d %gx%g+%g+%g +%g+%g %d '%s' '%s' '%s' '%s' %s",

/* -s @ % * ! ? gs ps 'def' 'l' 'des' v 'val' 'literal value' */
*string_print = "-s %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s '%s' '%s'",

/* -s @ % * ! ? gs ps 'def' 'l' 'des' v */
*string_write = "-s %d %d %d %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' %s",

/* -c @ % * ! ? gs ps num val 'l' 'des' v */
*cycle_print = "-c %d %d %d %d %d %gx%g+%g+%g +%g+%g %d %d '%s' '%s' %s",

/* -x @ % * ! ? gs ps num val 'l' 'des' v */
*list_print = "-x %d %d %d %d %d %gx%g+%g+%g +%g+%g %d %d '%s' '%s' %s",

/* -R @ gs 'l' 'des' com */
*routine_print = "-R %d %d %d %gx%g+%g+%g '%s' '%s' %s",

/*  -T @ % * ! ? gs ps def  'l' 'des' v */
*toggle_print = "-T %d %d %d %d %d %gx%g+%g+%g +%g+%g %d '%s' '%s' %s %d",

/*  -T @ % * ! ? gs ps def  'l' 'des' v val */
*toggle_write = "-T %d %d %d %d %d %gx%g+%g+%g +%g+%g %d '%s' '%s' %s",

/* -b ps 'l' */
*blank_print = "-b +%g+%g '%s'",

/* -a @ % gs 'l' 'des' v */
*pane_action_print = "-a %d %d %gx%g+%g+%g '%s' '%s' %s",

/* -p filename */
*includepane_print = "-p %s",

/* -k filename */
*includesubform_print = "-k %s",

/* -w gs ps 'l' 'des' v val */
*workspace_print = "-w %gx%g+%g+%g +%g+%g '%s' '%s' %s %d",

/* -w gs ps 'l' 'des' v val */
*workspace_write = "-w %gx%g+%g+%g +%g+%g '%s' '%s' %s",

/* -L library_call */
*libcall_print = "-L %s",

/* -A @ %  gs ps 'def' 'l' 'val' 'literal value' */
*ansinfile_print = "-A %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' '%s'",

/* -A @ %  gs ps 'def' 'l' */
*ansinfile_write = "-A %d %d %gx%g+%g+%g +%g+%g '%s' '%s'",

/* -Z @ %  gs ps 'def' 'l' 'val' 'literal value' */
*ansoutfile_print = "-Z %d %d %gx%g+%g+%g +%g+%g '%s' '%s' '%s' '%s'",

/* -Z @ %  gs ps 'def' 'l' */
*ansoutfile_write = "-Z %d %d %gx%g+%g+%g +%g+%g '%s' '%s'";

#endif
/* Don't add after this line */
